#extension GL_ARB_texture_rectangle : enable

#include "shader/feqs.inc"
#include "shader/config.inc"

/*
 * Texture0: f values
 * Texture1: vector data
 * Texture2: voxel data
 */

uniform sampler2DRect TextureDF;	// unit 0
uniform sampler2DRect TextureVector;	// unit 1
uniform sampler2DRect TextureVoxel;	// unit 2
uniform vec3 res;
uniform float ft_z_mod;
uniform float omega;
uniform vec3 gravitation;

void main(void)
{
	vec2 pr = floor(vec2(gl_TexCoord[0]));		// texture position in rectangle texture coordinates
	vec2 tmpv2 = floor(pr.xy/res.xy);
	float pos_z = tmpv2.x + tmpv2.y * ft_z_mod;	// z position

	vec4 f = texture2DRect(TextureDF, pr);		// load distribution functions
	float voxel = texture2DRect(TextureVoxel, pr).a;	// load "voxel or fluid" information at cell

#if HANDLE_GAS
	// TODO: avoid computation if gas cell
#endif

/*
#if DEBUG_SHADER
	if (f.r == 666.0)
	{
		gl_FragColor = f;
		return;
	}
#endif
*/
