#include "shader/collision_header.inc"

#include "shader/collision_io_velocity.inc"
	{
		gl_FragColor = f_eq2(io_velocity);
		return;
	}
#endif	// INJECT_IO_VELOCITY from shader/collision_io_velocity.inc

	if (voxel > 0.5)			// bounce back
	{
		gl_FragColor = vec4(f.g, f.r, f.a, f.b);
		return;
	}

	vec4 u = texture2DRect(TextureVector, pr);	// vector generated data

	vec4 grav = vec4(	gravitation[0] + gravitation[2],
				-gravitation[0] - gravitation[2],
				gravitation[0] - gravitation[2],
				-gravitation[0] + gravitation[2]
			) * (1.0/36.0)*u[3];

	// f(1,0,1), f(-1,0,-1), f(1,0,-1), f(-1,0,1)
	gl_FragColor = f + omega * (f_eq2(u) - f) + grav;	// x-z plane
	return;
}
