#include "shader/collision_header.inc"

#include "shader/collision_io_velocity.inc"
	{
		gl_FragColor = vec4(f_eq4(io_velocity), (voxel > 0.5 ? 1.0 : 0.0));
		return;
	}
#endif	// INJECT_IO_VELOCITY from shader/collision_io_velocity.inc

	if (voxel > 0.5)			// bounce back
	{
		gl_FragColor = vec4(f.g, f.r, f.b, 1.0);
		return;
	}

	vec4 u = texture2DRect(TextureVector, pr);	// vector generated data

	vec3 grav = vec3(	-gravitation[2],
				+gravitation[2],
				0.0
			) * (1.0/18.0)*u[3];

	// f(0,0,-1) f(0,0,1)
	gl_FragColor = vec4(f.rgb + omega * (f_eq4(u) - f.rgb) + grav, (voxel > 0.5 ? 1.0 : 0.0));
	return;
}
