
/**
 * feqN
 * calculate equlibrium density distributions for texture N
 * \param u	velocity and density
 */
vec4 f_eq0(vec4 u)
{
	float phi = u[3];
	float u_2 = u[0]*u[0] + u[1]*u[1] + u[2]*u[2];

	vec4 tmpv = vec4(u[0], -u[0], u[1], -u[1]);
	return (1.0/18.0)*(phi + 3.0*tmpv + (tmpv*tmpv)*(9.0/2.0) - u_2*(3.0/2.0));
//	return phi*((1.0/18.0) + tmpv*(1.0/6.0) + (tmpv*tmpv)*(1.0/4.0) - u_2*(1.0/12.0));
}

vec4 f_eq1(vec4 u)
{
	float phi = u[3];
	float u_2 = u[0]*u[0] + u[1]*u[1] + u[2]*u[2];

	vec4 tmpv = vec4(u[0] + u[1], -u[0] - u[1], u[0] - u[1], -u[0] + u[1]);
	return (1.0/36.0)*(phi + 3.0*tmpv + (tmpv*tmpv)*(9.0/2.0) - u_2*(3.0/2.0));
//	return (1.0/36.0)*(phi + tmpv*(1.0/12.0) + (tmpv*tmpv)*(1.0/8.0) - u_2*(1.0/24.0));
//	return phi*((1.0/36.0) + tmpv*(1.0/12.0) + (tmpv*tmpv)*(1.0/8.0) - u_2*(1.0/24.0));
}

vec4 f_eq2(vec4 u)
{
	float phi = u[3];
	float u_2 = u[0]*u[0] + u[1]*u[1] + u[2]*u[2];

	vec4 tmpv = vec4(u[0] + u[2], -u[0] - u[2], u[0] - u[2], -u[0] + u[2]);
	return (1.0/36.0)*(phi + 3.0*tmpv + (tmpv*tmpv)*(9.0/2.0) - u_2*(3.0/2.0));
//	return (1.0/36.0)*(phi + tmpv*(1.0/12.0) + (tmpv*tmpv)*(1.0/8.0) - u_2*(1.0/24.0));
//	return phi*((1.0/36.0) + tmpv*(1.0/12.0) + (tmpv*tmpv)*(1.0/8.0) - u_2*(1.0/24.0));
}

vec4 f_eq3(vec4 u)
{
	float phi = u[3];
	float u_2 = u[0]*u[0] + u[1]*u[1] + u[2]*u[2];

	vec4 tmpv = vec4(u[1] + u[2], -u[1] - u[2], u[1] - u[2], -u[1] + u[2]);
	return (1.0/36.0)*(phi + 3.0*tmpv + (tmpv*tmpv)*(9.0/2.0) - u_2*(3.0/2.0));
//	return (1.0/36.0)*(phi + tmpv*(1.0/12.0) + (tmpv*tmpv)*(1.0/8.0) - u_2*(1.0/24.0));
//	return phi*((1.0/36.0) + tmpv*(1.0/12.0) + (tmpv*tmpv)*(1.0/8.0) - u_2*(1.0/24.0));
}

vec3 f_eq4(vec4 u)
{
	float phi = u[3];
	float u_2 = u[0]*u[0] + u[1]*u[1] + u[2]*u[2];

	vec3 f_eq;
	float tmp;

	// TODO: optimize me
	// f(0,0,1)
	tmp = u[2];
	f_eq[0] = (1.0/18.0)*(phi + 3.0*tmp + (tmp*tmp)*(9.0/2.0) - u_2*(3.0/2.0));
//	f_eq[0] = phi*((1.0/18.0) + tmp*(1.0/6.0) + (tmp*tmp)*(1.0/4.0) - u_2*(1.0/12.0));

	// f(0,0,-1)
	tmp = -u[2];
	f_eq[1] = (1.0/18.0)*(phi + 3.0*tmp + (tmp*tmp)*(9.0/2.0) - u_2*(3.0/2.0));
//	f_eq[1] = phi*((1.0/18.0) + tmp*(1.0/6.0) + (tmp*tmp)*(1.0/4.0) - u_2*(1.0/12.0));

	// f(0,0,0)
	f_eq[2] = (1.0/3.0)*(phi - u_2*(3.0/2.0));
//	f_eq[2] = phi*((1.0/3.0) - u_2*(3.0/2.0));

	return f_eq;
}
