#extension GL_ARB_texture_rectangle : enable
#include "shader/config.inc"

/**
 */
uniform sampler2DRect Texture0;
uniform float factor, add;
uniform int alpha_color;

void main(void)
{
	vec4 color = texture2DRect(Texture0, vec2(gl_TexCoord[0]));

	if (alpha_color == 1)
	{
#if DEBUG_SHADER
			// use alpha channel for better visualization
			if (color.a == 0.0)
				color = vec4(0, 0, 0, 0);
			else if (color.a == 1.0)
				color = vec4(1, 0, 0, 0);
			else if (color.a == 2.0)
				color = vec4(0, 1, 0, 0);
			else if (color.a == 3.0)
				color = vec4(0, 0, 1, 0);
			else
				color = vec4(1, 1, 1, 1);
#else
			if (color.g == -1.0)
				color = vec4(0, 0, 0, 0);
			else if (color.g == 0.0)
				color = vec4(1, 0, 0, 0);
			else if (color.g == 2.0)
				color = vec4(0, 1, 0, 0);
			else if (color.g == 1.0)
				color = vec4(0, 0, 1, 0);
			else
				color = vec4(1, 1, 1, 0);
#endif
	}

	color = color*factor+add;

	gl_FragColor = color;
	return;
}
