#extension GL_ARB_texture_rectangle : enable
#extension GL_ARB_draw_buffers : enable 


uniform vec3 res;
uniform vec3 res_sub_1;
uniform float ft_z_mod;

#include "shader/feqs.inc"
#include "shader/config.inc"

/**
 * the texture with the new fluid fraction values created in the first
 * update_cell_state step
 */
uniform sampler2DRect TextureDF;
uniform sampler2DRect TextureFluidFraction;
uniform sampler2DRect TextureVelocityDensity;

vec4 getFrac(float x, float y, float z)
{
	vec3 p = clamp(vec3(x,y,z), vec3(0.0), res_sub_1);

	vec2 tmpv = vec2(mod(p.z, ft_z_mod), floor(p.z / ft_z_mod));
	return texture2DRect(TextureFluidFraction, p.xy + tmpv*res.xy);
}


void main(void)
{
	vec2 pr = floor(vec2(gl_TexCoord[0]));
	vec4 f = texture2DRect(TextureDF, pr);
	vec4 fluid_fraction = texture2DRect(TextureFluidFraction, pr);


