#extension GL_ARB_texture_rectangle : enable

uniform vec3 res;
uniform float tex_z_mod, tex_y_mod, tex_x_mod;	// count of slices aligned in texture x axis

uniform sampler2DRect	TextureZ,	// 0 -> Z Slices
			TextureY,	// 1 -> Y Slices
			TextureX;	// 2 -> X Slices

void main(void)
{
	/*
	 the value from gl_TexCoord mod 1 is somewhere around 0.499999999
	if (val > 0.49999998510)
	{
		gl_FragColor = vec4(1,0,0,0);
		return;
	}
	*/
	vec2 pr = floor(vec2(gl_TexCoord[0]));

	vec3 pos;
	pos.xy = floor(pr.xy / res.xy);
	pos.z = pos.x + pos.y * tex_z_mod;
	pos.xy = mod(pr.xy, res.xy);

// texture sliced through z axis
	float outputx = texture2DRect(TextureZ, pr).a;

// texture sliced through y axis
	pr.xy = vec2(mod(pos.y, tex_y_mod), floor(pos.y / tex_y_mod));
	pr.xy = pos.xz + pr.xy*res.xz;
	outputx = max(texture2DRect(TextureY, pr).a, outputx);

// texture sliced through x axis (z axis == height, y axis == width)
	pr.xy = vec2(mod(pos.x, tex_x_mod), floor(pos.x / tex_x_mod));
	pr.xy = pos.yz + pr.xy*res.yz;
	outputx = max(texture2DRect(TextureX, pr).a, outputx);

	gl_FragColor = vec4(outputx);

}
