#extension GL_ARB_texture_rectangle : enable

uniform float texture_width, texture_height;	// texture width+height
uniform sampler2DRect TextureDepth;

uniform vec3 res;
uniform vec2 inv_texture_size;
uniform float inv_res_x_mul_0_5;

varying vec3 normal;

void main(void)
{
	vec2 pr = floor(gl_FragCoord.xy);

	pr.x -= res.y;
	// THIS DOESNT WORK!!! -> texture wrap is set to repeat - so we dont have to care about the x coordinate
	if (pr.x < 0.0)
	{
		pr.y -= res.z;
		pr.x += texture_width;
	}

	float prevDepthValue = texture2DRect(TextureDepth, pr).x;

	// add inv_res_x_mul_0_5 as extra depth to avoid infinite depth peeling loop
	if (prevDepthValue+inv_res_x_mul_0_5 >= gl_FragCoord.z)	// previous depth buffer < current pixel < new depth buffer
		discard;

	gl_FragColor = vec4(normal, gl_FragCoord.z);
}
