/*
 * This file is part of the Lattice Boltzmann Open Surface program (lbm_os).
 *
 * lbm_os is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * lbm_os is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with lbm_os.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef MATH_HELP_H
#define MATH_HELP_H

#include <iostream>
#include <math.h>

// sunhalle stuff

#ifndef fabsf
#define	m_fabsf(x)	(::fabs(x))
#else
#define	m_fabsf(x)	(::fabsf(x))
#endif

#ifndef floorf
#define	m_floorf(x)	(::floor(x))
#else
#define	m_floorf(x)	(::floorf(x))
#endif

#ifndef ceilf
#define	m_ceilf(x)	(::ceil(x))
#else
#define	m_ceilf(x)	(::ceilf(x))
#endif

#ifndef sqrtf
#define	m_sqrtf(x)	(::sqrt(x))
#else
#define	m_sqrtf(x)	(::sqrtf(x))
#endif

#ifndef sqrtl
#define	m_sqrtl(x)	((unsigned long)::sqrt((double)x))
#else
#define	m_sqrtl(x)	((unsigned long)::sqrtl((unsigned long)x))
#endif


#ifndef roundf
#define m_roundf(x)	((float)(int)(x+0.5f))
#else
#define m_roundf(x)	(::roundf(x))
#endif

#ifndef round
#define m_round(x)	((double)(int)(x+0.5))
#else
#define m_round(x)	(round(x))
#endif


#endif
