/*
 * This file is part of the Lattice Boltzmann Open Surface program (lbm_os).
 *
 * lbm_os is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * lbm_os is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with lbm_os.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __FONT_H
#define __FONT_H

#include "CTexture.hpp"

class CFont
{
	private:
		CTexture *fontTexture;
		GLuint fontDisplayList;
		float charWidth, charHeight;
		float scaleX, scaleY;

	public:
		int init;
#ifdef __WIN32__
		CFont(const char *file = "images\\fontmap.png");
#else
		CFont(const char *file = "images/fontmap.png");
#endif

		void fontSize(float size);
		void printfxy(int x, int y, const char *format, ...);
};


#endif
