/*
 * This file is part of the Lattice Boltzmann Open Surface program (lbm_os).
 *
 * lbm_os is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * lbm_os is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with lbm_os.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * \file dspObjfile.h
 * \brief display data from ObjFile class
 */

#ifndef DSP_OBJFILE_H
#define DSP_OBJFILE_H


#include "CObjFile.hpp"
#include "../libmath/CVector.hh"

bool renderObjfile(CObjFile &o, bool drawOnlyBorder = false, float r = 0.2, float g = 0.2, float b = 0.7);
bool renderObjfileVoxel(CObjFile &o, bool drawBorder = true);
bool renderObjfileVoxelWithNormals(CObjFile &o, bool drawBorder = true);


#endif
